using TBL.CSharp.Game.Server.Utilities;

namespace TBL.CSharp.Game.Server.Message;

/// <summary>
/// 服务器信号
/// </summary>
public readonly struct Signal
{
    /// <summary>
    /// 目标地址
    /// </summary>
    public readonly SignalAddress TargetAddress;
    
    /// <summary>
    /// 信号数据
    /// </summary>
    public readonly ByteBlock Data;

    public Signal(SignalAddress targetAddress, ByteBlock data)
    {
        TargetAddress = targetAddress;
        Data = data;
    }

    public Signal(SignalAddress targetAddress) : this(targetAddress, ByteBlock.Empty)
    {
    }
}