using TBL.CSharp.Game.Server.Message;

namespace TBL.CSharp.Game.Server;

/// <summary>
/// 服务
/// </summary>
public abstract class Service
{
    /// <summary>
    /// 服务队列
    /// </summary>
    public readonly SignalQueue SignalQueue;

    /// <summary>
    /// 服务句柄
    /// </summary>
    public int Handle { get; internal set; }

    /// <summary>
    /// 服务容器
    /// </summary>
    public ServiceContainer Container { get; internal set; }

    public Service()
    {
        SignalQueue = new SignalQueue(this);
    }

    /// <summary>
    /// 服务信号反应
    /// </summary>
    public abstract void OnSignal(Signal signal, ServiceContainer serviceContainer);
}